Index: orxonox/branches/levelloader/src/simple_animation.cc
===================================================================
--- orxonox/branches/levelloader/src/simple_animation.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/simple_animation.cc	(revision 3746)
@@ -1,2 +1,3 @@
+
 
 
@@ -19,87 +20,39 @@
 #include "simple_animation.h"
 #include "stdincl.h"
-#include "p_node.h"
+#include "vector.h"
+#include "world_entity.h"
 
 using namespace std;
 
+
+
+SimpleAnimation* SimpleAnimation::singletonRef = 0;
+/**
+   \brief gets the singleton instance
+   \returns singleton instance
+*/
+SimpleAnimation* SimpleAnimation::getInstance()
+{
+  if( singletonRef == NULL)
+    singletonRef = new SimpleAnimation();
+  return singletonRef;
+}
+
 /**
    \brief standard constructor
-   \param the point of the object
-   \param and the orientation of it
-   \param at this time
-*/
-KeyFrame::KeyFrame(Vector* point, Quaternion* orientation, float time)
-{
-  this->setRelCoor(point);
-  this->setRelDir(orientation);
-  this->time = time;
-}
-
-
-/**
-   \brief standard constructor
-   \param the point of the object
-   \param and the orientation of it
-   \param at this time
-   \param function of the velocity of the movement 
-*/
-KeyFrame::KeyFrame(Vector* point, Quaternion* orientation, float time, movementMode mode)
-{
-  this->setRelCoor(point);
-  this->setRelDir(orientation);
-  this->time = time;
-  this->mode = mode;
-}
-
-
-/**
-   \brief standard deconstructor
-*/
-KeyFrame::~KeyFrame()
-{
-}
-
-
-/**
-   \brief sets the important properties of a Keyframe
-   \param the point of the object
-   \param and the orientation of it
-   \param at this time
-*/
-void KeyFrame::set(Vector* point, Quaternion* orientation, float time)
-{
-  this->setRelCoor(point);
-  this->setRelDir(orientation);
-  this->time = time;
-}
-
-
-/**
-   \brief sets the important properties of a Keyframe
-   \param the point of the object
-   \param and the orientation of it
-   \param at this time
-   \param function of the velocity of the movement 
-*/
-void KeyFrame::set(Vector* point, Quaternion* orientation, float time, movementMode mode)
-{
-  this->setRelCoor(point);
-  this->setRelDir(orientation);
-  this->time = time;
-  this->mode = mode;
-}
-
-
-
-/**
-   \brief standard constructor
-*/
-SimpleAnimation::SimpleAnimation (PNode* parent) 
+*/
+SimpleAnimation::SimpleAnimation () 
 {
    this->setClassName ("SimpleAnimation");
    this->frames = new tList<KeyFrame>();
+   this->animators = new tList<Animation>();
    this->localTime = 0;
-   this->bPause = false;
-   this->parent = parent;
+   this->bRunning = false;
+   this->currentFrame = NULL;
+   this->lastFrame = NULL;
+
+   this->tmpVect = new Vector();
+   this->lastPosition = new Vector();
+   this->deltaT = 0.2;
 }
 
@@ -111,11 +64,71 @@
 SimpleAnimation::~SimpleAnimation () 
 {
-  KeyFrame* frame = this->frames->enumerate(); 
+  tIterator<KeyFrame>* iterator = this->frames->getIterator();
+  KeyFrame* frame = iterator->nextElement(); 
   while( frame != NULL) 
     { 
       delete frame;
-      frame = frames->nextElement();
-    }
+      frame = iterator->nextElement();
+    }
+  delete iterator;
   delete this->frames;
+}
+
+
+/**
+   \brief this determines the start of an Animator Describtion
+
+   this can then be followed by different commands like addKeyFrame(..) etc. and
+   will be closed with AnimatiorEnd()
+*/
+void SimpleAnimation::animatorBegin()
+{
+  this->bDescriptive = true;
+}
+
+
+/**
+   \brief this determines the end of an Animator Describtion
+
+   this can then be followed by different commands like addKeyFrame(..) etc. and
+   will be closed with AnimatiorEnd()
+*/
+void SimpleAnimation::animatorEnd()
+{
+  this->workingObject = NULL;
+  this->bDescriptive = false;
+}
+
+
+/*
+  Vector* lastPosition;
+  Vector* tmpVect;
+  tList<KeyFrame>* frames;
+  animationMode animMode;
+  movementMode movMode;
+  bool bRunning;
+  float deltaT;
+*/
+
+/**
+   \brief select an object to work on by using this function
+   \param object wo work on
+*/
+void SimpleAnimation::selectObject(WorldEntity* entity)
+{
+  Animation* anim = getAnimationFromWorldEntity(entity);
+  if( anim == NULL)
+    {
+      printf("SimpleAnimation::selectObject() - object not found, creating one\n");
+      anim = new Animation;
+      anim->object = entity;
+      anim->lastPosition = new Vector();
+      anim->tmpVect = new Vector();
+      frames = new tList<KeyFrame>();
+      bRunning = false;
+      deltaT = 0.0;
+      this->animators->add(anim);
+    }
+  this->workingAnimator = anim;
 }
 
@@ -125,10 +138,20 @@
    \brief adds a keyframe with properties
    \param the point of the object
-   \param and the orientation of it
+   \param and the direction of it
    \param at this time
 */
-void SimpleAnimation::addKeyFrame(Vector* point, Quaternion* orientation, float time)
-{
-  KeyFrame* frame = new KeyFrame(point, orientation, time);
+void SimpleAnimation::addKeyFrame(Vector* point, Quaternion* direction, float time)
+{
+  if( !this->bDescriptive)
+    {
+      PRINTF(1)("SimpleAnimation: executing animation code outside a AnimationBegin()/AnimationEnd() - ignoring\n");
+      return;
+    }
+  KeyFrame* frame = new KeyFrame;
+  frame->position = point;
+  frame->direction = direction;
+  frame->time = time;
+  frame->mode = DEFAULT_ANIMATION_MODE;
+  frame->object = this->workingObject;
   this->frames->add(frame);
 }
@@ -138,11 +161,21 @@
    \brief adds a keyframe with properties
    \param the point of the object
-   \param and the orientation of it
+   \param and the direction of it
    \param at this time
    \param function of the velocity of the movement 
 */
-void SimpleAnimation::addKeyFrame(Vector* point, Quaternion* orientation, float time, movementMode mode)
-{
-  KeyFrame* frame = new KeyFrame(point, orientation, time, mode);
+void SimpleAnimation::addKeyFrame(Vector* point, Quaternion* direction, float time, movementMode mode)
+{
+  if( !this->bDescriptive)
+    {
+      PRINTF(1)("SimpleAnimation: executing animation code outside a AnimationBegin()/AnimationEnd() - ignoring\n");
+      return;
+    }
+  KeyFrame* frame = new KeyFrame;
+  frame->position = point;
+  frame->direction = direction;
+  frame->time = time;
+  frame->mode = mode;
+  frame->object = this->workingObject;
   this->frames->add(frame);
 }
@@ -154,4 +187,10 @@
 void SimpleAnimation::addKeyFrame(KeyFrame* frame)
 {
+  if( !this->bDescriptive)
+    {
+      PRINTF(1)("SimpleAnimation: executing animation code outside a AnimationBegin()/AnimationEnd() - ignoring\n");
+      return;
+    }
+  frame->object = this->workingObject;
   this->frames->add(frame);
 }
@@ -163,16 +202,20 @@
 void SimpleAnimation::reset()
 {
-  KeyFrame* frame = this->frames->enumerate(); 
+  tIterator<KeyFrame>* iterator = this->frames->getIterator();
+  KeyFrame* frame = iterator->nextElement(); 
   while( frame != NULL) 
     { 
       delete frame;
-      frame = frames->nextElement();
-    }
+      frame = iterator->nextElement();
+    }
+  delete iterator;
   delete this->frames;
 
   this->frames = new tList<KeyFrame>();
   this->localTime = 0;
-  this->bPause = false;
-
+  this->bRunning = false;
+
+  this->currentFrame = NULL;
+  this->lastFrame = NULL;
 }
 
@@ -181,5 +224,16 @@
 */
 void SimpleAnimation::start()
-{}
+{
+  if( this->bRunning)
+    {
+      PRINTF(2)("SimpleAnimatin is already running. You are trying to start it again.\n");
+    return;
+    }
+  
+  this->localTime = 0;
+  this->lastFrame = this->frames->firstElement();
+  this->currentFrame = this->frames->nextElement(this->currentFrame);
+  this->bRunning = true;
+}
 
 
@@ -188,5 +242,7 @@
 */
 void SimpleAnimation::stop()
-{}
+{
+  this->bRunning = false;
+}
 
 /**
@@ -196,5 +252,7 @@
 {
   this->localTime = 0;
-  this->bPause = false;
+  this->lastFrame = this->frames->firstElement();
+  this->currentFrame = this->frames->nextElement(this->currentFrame);
+  this->bRunning = true;
 }
 
@@ -204,5 +262,5 @@
 void SimpleAnimation::pause()
 {
-  this->bPause = true;
+  this->bRunning = false;
 }
 
@@ -212,5 +270,5 @@
 void SimpleAnimation::resume()
 {
-  this->bPause = false;
+  this->bRunning = true;
 }
 
@@ -221,9 +279,85 @@
 void SimpleAnimation::tick(float time)
 {
-  if(!this->bPause)
-    {
-
-
-
-    }
-}
+  this->localTime += time;
+  tIterator<Animation>* iterator = this->animators->getIterator();
+  Animation* anim = iterator->nextElement();
+  while( anim != NULL)
+    {
+      if( anim->bRunning)
+	{
+	  
+	  
+	  /* first get the current frame via time-stamps */ 
+	  while( this->localTime > anim->currentFrame->time)
+	    {
+	      printf("SimpleAnimation::tick(...) - changing Frame\n");
+	      
+	      //this->currentFrame->object->setRelCoor(*this->currentFrame->position);
+	      *anim->lastPosition = *anim->currentFrame->position;
+	      
+	      anim->lastFrame = anim->currentFrame;
+	      anim->currentFrame = anim->frames->nextElement(anim->currentFrame);
+	      anim->movMode = anim->currentFrame->mode;
+	      if( anim->movMode == NEG_EXP)
+		{
+		  *anim->tmpVect = *anim->currentFrame->position - *anim->lastFrame->position;
+		  anim->deltaT = 1/anim->currentFrame->time * logf(1.0 + 600.0/anim->tmpVect->len());
+		}
+	    }
+	  
+	  /* now animate it */
+	  switch( anim->movMode)
+	    {
+	    case LINEAR:
+	      
+	      *anim->tmpVect = *anim->currentFrame->position - *anim->lastFrame->position;
+	      *anim->tmpVect = *anim->tmpVect * this->localTime / anim->currentFrame->time;
+	      anim->currentFrame->object->setRelCoor(*anim->lastFrame->position + *anim->tmpVect);
+	      *anim->lastPosition = *anim->tmpVect;
+	      break;
+	    case EXP:
+	      
+	      break;
+	    case NEG_EXP:
+	      *anim->tmpVect = *anim->currentFrame->position - *anim->lastFrame->position;
+	      *anim->tmpVect = *anim->tmpVect * (1 - exp(- this->localTime * anim->deltaT));     
+	      anim->currentFrame->object->setRelCoor(*anim->lastFrame->position + *anim->tmpVect);
+	      *anim->lastPosition = *anim->tmpVect;
+	      break;
+	    case SIN:
+	      *anim->tmpVect = *anim->currentFrame->position - *anim->lastFrame->position;
+	      *anim->tmpVect = *anim->tmpVect * 0.5*(1 - cos(M_PI * this->localTime / anim->currentFrame->time));     
+	      anim->currentFrame->object->setRelCoor(*anim->lastFrame->position + *anim->tmpVect);
+	      *anim->lastPosition = *anim->tmpVect;
+	      break;
+	    case COS:
+	      
+	      break;
+	    case QUADRATIC:
+	      *anim->tmpVect = *anim->currentFrame->position - *anim->lastFrame->position;
+	      *anim->tmpVect = *anim->tmpVect * 1/3 * ldexpf(this->localTime, 3);
+	      break;
+	    default:
+	      break;
+	    }
+	}
+      anim = iterator->nextElement();
+    }
+  delete anim;
+}
+
+
+
+Animation* SimpleAnimation::getAnimationFromWorldEntity(WorldEntity* entity)
+{
+  tIterator<Animation>* iterator = this->animators->getIterator();
+  Animation* anim = iterator->nextElement();
+  while( anim != NULL)
+    {
+      if( anim->object == entity)
+	return anim;
+      anim = iterator->nextElement();
+    }
+  delete iterator;
+  return NULL;
+}
Index: orxonox/branches/levelloader/src/simple_animation.h
===================================================================
--- orxonox/branches/levelloader/src/simple_animation.h	(revision 3606)
+++ orxonox/branches/levelloader/src/simple_animation.h	(revision 3746)
@@ -12,29 +12,45 @@
 
 #include "base_object.h"
-#include "p_node.h"
 #include "list.h"
 
 
-typedef enum movementMode{LINEAR=0, EXP, NEG_EXP, SIN, COS};
+class Vector;
+class Quaternion;
+class WorldEntity;
+class PNode;
+
+typedef enum movementMode{LINEAR=0, EXP, NEG_EXP, SIN, COS, QUADRATIC};
+typedef enum animationMode{SINGLE=0, LOOP};
+#define DEFAULT_ANIMATION_MODE LINEAR
 
 
-//! KeyFrame Class
+//! KeyFrame Struct
 /**
-   This represents one point with orientation of the animation
+   This represents one point with direction of the animation
 */
-class KeyFrame : public PNode {
- public:
-  KeyFrame(Vector* point, Quaternion* orientation, float time);
-  KeyFrame(Vector* point, Quaternion* orientation, float time, movementMode mode); 
-  virtual ~KeyFrame();
-
-  void set(Vector* point, Quaternion* orientation, float time);
-  void set(Vector* point, Quaternion* orientation, float time, movementMode mode);
-  
- private:
+typedef struct KeyFrame {
+  Vector* position;
+  Quaternion* direction;
+  WorldEntity* object;
   float time;
   movementMode mode;
 };
 
+//! Animation Struct
+/**
+   This represents an animation for a object
+*/
+typedef struct Animation {
+  WorldEntity* object;
+  KeyFrame* currentFrame;
+  KeyFrame* lastFrame;
+  Vector* lastPosition;
+  Vector* tmpVect;
+  tList<KeyFrame>* frames;
+  animationMode animMode;
+  movementMode movMode;
+  bool bRunning;
+  float deltaT;
+};
 
 //! Animation Class
@@ -45,11 +61,14 @@
   
  public:
-  SimpleAnimation(PNode* parent);
-  virtual ~SimpleAnimation();
+  static SimpleAnimation* getInstance();
 
-  void addKeyFrame(Vector* point, Quaternion* orientation, float time);
-  void addKeyFrame(Vector* point, Quaternion* orientation, float time, movementMode mode);
+  void animatorBegin();
+  void animatorEnd();
+  void selectObject(WorldEntity* entity);
+  void addKeyFrame(Vector* point, Quaternion* direction, float time);
+  void addKeyFrame(Vector* point, Quaternion* direction, float time, movementMode mode);
   void addKeyFrame(KeyFrame* frame);
   void reset();
+
 
   void start();
@@ -62,9 +81,25 @@
 
  private:
-  bool bPause;                     //<! is set, when there is a pause
-  tList<KeyFrame>* frames;        //<! where keyframes are stored in
+  SimpleAnimation();
+  virtual ~SimpleAnimation();
+
+  static SimpleAnimation* singletonRef;
+  bool bDescriptive;               //<! is true, when AnimatorBegin() was executed but no AnimatorEnd() yet: in describtive mode: pass commands
+  bool bRunning;                   //<! is set, when the animation is running
+  tList<KeyFrame>* frames;         //<! where keyframes are stored in
+  tList<Animation>* animators;      //<! a list of animation's
+  KeyFrame* currentFrame;          //<! the frame that is been played now
+  KeyFrame* lastFrame;
+  Vector* lastPosition;
+  movementMode mode;               //<! this is an enum of the mode, how the speed is distributed
   float localTime;
   PNode* parent;
   
+  Vector* tmpVect;                 //<! this is the temporary vector save place - 
+  WorldEntity* workingObject;      //<! this is a pointer to the current working object that has been selected via selectObject()
+  Animation* workingAnimator;       //<! the animator with which you are currently working
+  float deltaT;                    //<! this is a time constant for the movement
+
+  Animation* getAnimationFromWorldEntity(WorldEntity* entity);
 
 };
Index: orxonox/branches/levelloader/src/story_entities/campaign.cc
===================================================================
--- orxonox/branches/levelloader/src/story_entities/campaign.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/story_entities/campaign.cc	(revision 3746)
@@ -18,10 +18,14 @@
 
 #include "campaign.h"
+
+#include "story_entity.h"
+
 #include "world.h"
 #include "camera.h"
-#include "story_entity.h"
 #include "factory.h"
 #include "game_loader.h"
 
+#include "list.h"
+
 using namespace std;
 
@@ -30,7 +34,8 @@
 Campaign::Campaign () 
 {
-  this->entities = new ListTemplate<StoryEntity>();
+  this->entities = new tList<StoryEntity>();
   this->isInit = false;
 }
+
 
 Campaign::~Campaign () {}
@@ -47,5 +52,5 @@
 	GameLoader* loader = GameLoader::getInstance();
 	
-  this->entities = new ListTemplate<StoryEntity>();
+  this->entities = new tList<StoryEntity>();
   this->isInit = false;
   
@@ -106,4 +111,5 @@
     {
       se->displayLoadScreen();
+      se->preLoad();
       se->load();
       se->init();
@@ -232,5 +238,7 @@
   if( storyID == WORLD_ID_GAMEEND)
     return NULL;
-  ListTemplate<StoryEntity>* l;
+
+  /*
+  tList<StoryEntity>* l;
   StoryEntity* entity = NULL;
   l = this->entities->getNext();  
@@ -239,4 +247,5 @@
       entity = l->getObject();
       l = l->getNext();
+
       int id = entity->getStoryID();
       //printf("Campaing::getStoryEntity() - now looping, found entity nr=%i\n", id);
@@ -246,5 +255,25 @@
 	  return entity;
 	}
-    }
+
+    }
+  */
+
+
+
+  StoryEntity* entity = this->entities->enumerate();
+  while( entity != NULL) 
+    { 
+      int id = entity->getStoryID();
+      //printf("Campaing::getStoryEntity() - now looping, found entity nr=%i\n", id);
+      if(id == storyID)
+	{
+	  //printf("Campaing::getStoryEntity() - yea, this is what we where looking for: %id\n");
+	  return entity;
+	}
+      entity = this->entities->nextElement();
+    }
+
+
+
   return NULL;
 }
Index: orxonox/branches/levelloader/src/story_entities/campaign.h
===================================================================
--- orxonox/branches/levelloader/src/story_entities/campaign.h	(revision 3606)
+++ orxonox/branches/levelloader/src/story_entities/campaign.h	(revision 3746)
@@ -8,4 +8,5 @@
 
 class World;
+template<class T> class tList;
 
 class Campaign : public StoryEntity {
@@ -34,5 +35,6 @@
 
  private:
-  ListTemplate<StoryEntity>* entities;
+  //ListTemplate<StoryEntity>* entities;
+  tList<StoryEntity>* entities;
   bool running;
 
Index: orxonox/branches/levelloader/src/story_entities/story_entity.cc
===================================================================
--- orxonox/branches/levelloader/src/story_entities/story_entity.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/story_entities/story_entity.cc	(revision 3746)
@@ -72,4 +72,24 @@
 
 
+/**
+   \brief stuff that will have to be initialized before load
+
+   this gives all storyentities the possibility to init stuff before the
+   load function, where all the stuff is been made ready for start
+*/
+ErrorMessage StoryEntity::preLoad()
+{}
+
+/** 
+    \brief loads the current entity
+
+    this is here to enable you loading maps into the entities. for all other actions you
+    should take the init() function.
+    load() is exec before init()
+*/
+ErrorMessage StoryEntity::load()
+{}
+
+
 /** 
     \brief initialize the entity before use. 
@@ -78,17 +98,9 @@
     After execution of this function, the Entity is ready to be played/executed, 
     this shifts the initialisation work before the execution - very important...
+    init() is exec shortly before start()
 */
 ErrorMessage StoryEntity::init()
 {}
 
-
-/** 
-    \brief loads the current entity
-
-    this is here to enable you loading maps into the entities. for all other actions you
-    should take the init() function.
-*/
-ErrorMessage StoryEntity::load()
-{}
 
 /** 
Index: orxonox/branches/levelloader/src/story_entities/story_entity.h
===================================================================
--- orxonox/branches/levelloader/src/story_entities/story_entity.h	(revision 3606)
+++ orxonox/branches/levelloader/src/story_entities/story_entity.h	(revision 3746)
@@ -8,7 +8,9 @@
 #define _STORY_ENTITY_H
 
-#include "stdincl.h"
+#include "base_object.h"
 
 #include "story_def.h"
+#include "error.h"
+
 
 //! A class that represents something to play in orxonox. it is a container for worlds, movies, mission briefings, etc...
@@ -23,4 +25,5 @@
   bool isPaused; //! is true if the entity is paused
 
+  virtual ErrorMessage preLoad();
   virtual ErrorMessage load();
   virtual ErrorMessage init();
Index: orxonox/branches/levelloader/src/story_entities/world.cc
===================================================================
--- orxonox/branches/levelloader/src/story_entities/world.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/story_entities/world.cc	(revision 3746)
@@ -18,18 +18,27 @@
 
 #include "world.h"
-#include "world_entity.h"
-#include "track_manager.h"
-#include "player.h"
-#include "command_node.h"
-#include "camera.h"
-#include "environment.h"
-#include "primitive.h"
+
+#include "orxonox.h"
+
 #include "p_node.h"
 #include "null_parent.h"
 #include "helper_parent.h"
+#include "track_node.h"
+#include "world_entity.h"
+#include "player.h"
+#include "camera.h"
+#include "environment.h"
+#include "skysphere.h"
+#include "terrain.h"
+#include "light.h"
+
+#include "track_manager.h"
+#include "garbage_collector.h"
+#include "simple_animation.h"
+
+#include "command_node.h"
 #include "glmenu_imagescreen.h"
-#include "skysphere.h"
-#include "light.h"
 #include "fontset.h"
+#include "list.h"
 #include "factory.h"
 #include "game_loader.h"
@@ -37,7 +46,75 @@
 #include "terrain.h"
 
+
+
 using namespace std;
 
 CREATE_FACTORY(World);
+
+WorldInterface* WorldInterface::singletonRef = 0;
+
+
+/**
+   \brief private constructor because of singleton
+*/
+WorldInterface::WorldInterface()
+{
+  this->worldIsInitialized = false;
+  this->worldReference = NULL;
+}
+
+/**
+   \brief public deconstructor
+*/
+WorldInterface::~WorldInterface()
+{
+  this->singletonRef = NULL;
+  this->worldIsInitialized = false;
+  this->worldReference = NULL;
+}
+
+/**
+   \brief gets the singleton instance
+   \returns singleton instance
+*/
+WorldInterface* WorldInterface::getInstance()
+{
+  if( singletonRef == NULL)
+    singletonRef = new WorldInterface();
+  return singletonRef;
+}
+
+
+/**
+   \brief initializes the interface
+   \param reference to the world
+
+   if the worldinterface is not initilizes, there wont be any 
+   useable interface
+*/
+void WorldInterface::init(World* world)
+{
+  this->worldReference = world;
+  if( world != NULL)
+    {
+      this->worldIsInitialized = true;
+      PRINTF(3)("WorldInterface up and running\n");
+    }
+}
+
+
+/**
+   \brief gets the entity list from the world
+   \return entity list
+*/
+tList<WorldEntity>* WorldInterface::getEntityList()
+{
+  if( this->worldIsInitialized)
+    return this->worldReference->getEntities();
+  PRINT(1)("Someone tried to use the WorldInterface before it has been initizlized! this can result in SEGFAULTs!\n");
+  return NULL;
+}
+
+
 
 World::World( TiXmlElement* root)
@@ -110,4 +187,10 @@
   cn->reset();
 
+  ResourceManager::getInstance()->debug();
+  ResourceManager::getInstance()->unloadAllByPriority(RP_LEVEL);
+  ResourceManager::getInstance()->debug();
+
+  delete WorldInterface::getInstance();
+
   delete this->nullParent;
   delete this->entities;
@@ -116,8 +199,17 @@
   if( this->worldName) delete this->worldName;
   if( this->path) delete this->path;
-}
-
-/**
-   \brief initializes a new World
+
+  //delete garbagecollecor
+  //delete animator
+}
+
+/**
+   \brief initializes the world. 
+
+   set all stuff here that is world generic and does not use to much memory
+   because the real init() function StoryEntity::init() will be called
+   shortly before start of the game.  
+   since all worlds are initiated/referenced before they will be started.
+   NO LEVEL LOADING HERE - NEVER!
 */
 void World::init(char* name, int worldID)
@@ -128,8 +220,20 @@
   this->debugWorldNr = worldID;
   this->entities = new tList<WorldEntity>();
-
-  // Enable default GL stuff
-  glEnable(GL_DEPTH_TEST);
-
+}
+
+
+/**
+   \brief this is executed before load
+
+   since the load function sometimes needs data, that has been init before
+   the load and after the proceeding storyentity has finished
+*/
+ErrorMessage World::preLoad()
+{
+  /* init the world interface */
+  WorldInterface* wi = WorldInterface::getInstance();
+  wi->init(this);
+  this->garbageCollector = GarbageCollector::getInstance();
+  this->simpleAnimation = SimpleAnimation::getInstance();
 }
 
@@ -153,4 +257,5 @@
 	// load the campaign document
 	if( !XMLDoc->LoadFile())
+      this->glmis->step();
 
 	{
@@ -257,7 +362,7 @@
     
     	// bind camera
-    this->localCamera = new Camera(this);
+    this->localCamera = new Camera();
     this->localCamera->setName ("camera");
-    this->localCamera->bind (localPlayer);
+    //this->localCamera->bind (localPlayer);
     this->localPlayer->addChild (this->localCamera);
 
@@ -267,4 +372,17 @@
       /*monitor progress*/
   //  this->glmis->step();
+
+      // LIGHT initialisation
+      lightMan = LightManager::getInstance();
+      lightMan->setAmbientColor(.1,.1,.1);
+      lightMan->addLight();
+      //      lightMan->setAttenuation(1.0, .01, 0.0);
+      //      lightMan->setDiffuseColor(1,1,1);
+      //  lightMan->addLight(1);
+      //  lightMan->setPosition(20, 10, -20);
+      //  lightMan->setDiffuseColor(0,0,0);
+      lightMan->debug();
+	    lightMan->setPosition(-5.0, 10.0, -40.0);
+
 
 	    // Create SkySphere
@@ -274,8 +392,15 @@
 	    this->skySphere->setMode(PNODE_MOVEMENT);
 
-	    /*monitor progress*/
-	  //  this->glmis->step();
-	  
-	  //  trackManager->setBindSlave(env);
+
+	    //	    trackManager->setBindSlave(env);
+	    PNode* tn = trackManager->getTrackNode();
+	    tn->addChild(this->localPlayer);
+
+	    //localCamera->setParent(TrackNode::getInstance());
+	    tn->addChild(this->localCamera);
+	    //	    localCamera->lookAt(tn);
+	    this->localPlayer->setMode(PNODE_ALL);
+	    //Vector* cameraOffset = new Vector (0, 5, -10);
+	    //trackManager->condition(2, LEFTRIGHT, this->localPlayer);
 
   // initialize debug coord system
@@ -290,9 +415,12 @@
   terrain->setRelCoor(new Vector(0,-10,0));
   this->spawn(terrain);
-
-}
-
-/**
-   \brief initializes a new World
+}
+
+
+/**
+   \brief initializes a new World shortly before start
+
+   this is the function, that will be loaded shortly before the world is 
+   started
 */
 ErrorMessage World::init()
@@ -302,5 +430,4 @@
   cn->addToWorld(this);
   cn->enable(true);
-
 PRINTF0("> Done Loading world: '%s'\n", getPath());
 }
@@ -363,5 +490,5 @@
   this->glmis = GLMenuImageScreen::getInstance();
   this->glmis->init();
-  this->glmis->setMaximum(10);
+  this->glmis->setMaximum(8);
   this->glmis->draw();
  
@@ -378,6 +505,26 @@
   PRINTF(3)("World::releaseLoadScreen - start\n"); 
   this->glmis->setValue(this->glmis->getMaximum());
-  SDL_Delay(500);
+  //SDL_Delay(500);
   PRINTF(3)("World::releaseLoadScreen - end\n"); 
+}
+
+
+/**
+   \brief gets the list of entities from the world
+   \returns entity list
+*/
+tList<WorldEntity>* World::getEntities()
+{
+  return this->entities;
+}
+
+
+/**
+   \brief this returns the current game time
+   \returns elapsed game time
+*/
+double World::getGameTime()
+{
+  return this->gameTime;
 }
 
@@ -435,10 +582,14 @@
   glLoadIdentity();
 
-  entity = this->entities->enumerate();
+  //entity = this->entities->enumerate();
+  tIterator<WorldEntity>* iterator = this->entities->getIterator();
+  entity = iterator->nextElement();
   while( entity != NULL ) 
     { 
       if( entity->bDraw ) entity->draw();
-      entity = this->entities->nextElement();
-    } 
+      //entity = this->entities->nextElement();
+      entity = iterator->nextElement();
+    }
+  delete iterator;
   
   glCallList (objectList);
@@ -477,5 +628,5 @@
   p4->debug ();
   
-  p1->update ();
+  p1->update (0);
 
   printf ("World::debug() - update\n");
@@ -486,5 +637,5 @@
 
   p2->shiftCoor (new Vector(-1, -1, -1));
-  p1->update ();
+  p1->update (0);
 
   p1->debug ();
@@ -496,5 +647,5 @@
 
 
- p1->update ();
+ p1->update (0);
 
   p1->debug ();
@@ -593,7 +744,7 @@
   if(!this->bPause)
     {
-      Uint32 dt = currentFrame - this->lastFrame;
+      this->dt = currentFrame - this->lastFrame;
       
-      if(dt > 0)
+      if( this->dt > 0)
 	{
 	  float fps = 1000/dt;
@@ -607,24 +758,29 @@
 	  PRINTF(2)("fps = 1000 - frame rate is adjusted\n");
 	  SDL_Delay(10);
-	  dt = 10;
+	  this->dt = 10;
 	}
       //this->timeSlice (dt);
       
       /* function to let all entities tick (iterate through list) */
-      WorldEntity* entity;
-      float seconds = dt / 1000.0;  
-      assert( this->nullParent != NULL); 
-      entity = entities->enumerate(); 
+      float seconds = this->dt / 1000.0;      
+      this->gameTime += seconds;
+      //entity = entities->enumerate(); 
+      tIterator<WorldEntity>* iterator = this->entities->getIterator();
+      WorldEntity* entity = iterator->nextElement();
       while( entity != NULL) 
 	{ 
 	  entity->tick (seconds);
-	  entity = entities->nextElement();
-	}
+	  entity = iterator->nextElement();
+	}
+      delete iterator;
+      //skySphere->updatePosition(localCamera->absCoordinate);
+      
       /* update tick the rest */
+      this->trackManager->tick(this->dt);
       assert( this->localCamera != NULL); 
       assert( this->trackManager != NULL); 
-      this->localCamera->tick(dt);
-
-      this->trackManager->tick(dt);
+      this->localCamera->tick(this->dt);
+      this->garbageCollector->tick(seconds);
+      this->simpleAnimation->tick(seconds);
     }
   this->lastFrame = currentFrame;
@@ -640,5 +796,6 @@
 void World::update()
 {
-  this->nullParent->update ();
+  this->garbageCollector->update();
+  this->nullParent->update (dt);
 }
 
@@ -728,4 +885,11 @@
 bool World::command(Command* cmd)
 {
+  if( !strcmp( cmd->cmd, "view0")) this->localCamera->setViewMode(VIEW_NORMAL);
+  else if( !strcmp( cmd->cmd, "view1")) this->localCamera->setViewMode(VIEW_BEHIND);
+  else if( !strcmp( cmd->cmd, "view2")) this->localCamera->setViewMode(VIEW_FRONT);
+  else if( !strcmp( cmd->cmd, "view3")) this->localCamera->setViewMode(VIEW_LEFT);
+  else if( !strcmp( cmd->cmd, "view4")) this->localCamera->setViewMode(VIEW_RIGHT);
+  else if( !strcmp( cmd->cmd, "view5")) this->localCamera->setViewMode(VIEW_TOP);
+  
   return false;
 }
